

/*******************************************************************************
 * Instance třídy {@code Zamestnanec} představuje jednoho zaměstance ve mzdové
 * účtárně.
 *
 * @author    Petr Bílek
 * @version   1.00.000
 */
public class Zamestnanec
{
//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================
//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================
//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================
//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================
    /**
     * Jméno zaměstnance
     */
    private String jmeno;
    /**
     * Příjmení zaměstnance
     */
    private String prijmeni;
    /**
     * Hrubá mzda zaměstnance v korunách.
     */
    private double hrubaMzda;
    
//== PŘÍSTUPOVÉ METODY ATRIBUTŮ TŘÍDY ==========================================
    /**
     * Vrací jméno zaměstnance
     * @return Jméno zaměstnance
     */
    public String getJmeno()
    {
        return jmeno;
    }

    /**
     * Vrací příjmení zaměstnance
     * @return Příjmení zaměstnance
     */
    public String getPrijmeni()
    {
        return prijmeni;
    }

     /**
     * Vrací hrubou mzdu zaměstnance
     * @return Hrubá mzda zaměstnance v korunách
     */
    public double getHrubaMzda()
    {
        return hrubaMzda;
    }

     /**
     * Vrací čistou mzdu zaměstnance pro rovnou daň 15%
     * @return Čistá mzda zaměstnance v korunách
     */
    public double getCistaMzda()
    {
        return hrubaMzda * 0.85;
    }


//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================
    /**
     * Zvyšuje hrubou mzdu zaměstnance o zadaný počet procent
     * @param procent Procenta, o které se bude zvyšovat hrubá mzda
     */
    public void pridej(double procent)
    {
        hrubaMzda = hrubaMzda * (1 + procent / 100); 
    }
    
    /**
     * Vrací textovou reprezentaci objektu
     * @return Textová reprezentace objektu
     */
    public String toString()
    {
        return String.format("Zaměstnanec %10s %10s má hrubou mzdu %,10.2f Kč"   +
                             " a čistou mzdu %,10.2f Kč.",
                    getJmeno(), getPrijmeni(), getHrubaMzda(), getCistaMzda());
    }

//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     *
     * Konstruktor třídy. Dovolí uložit pouze kladnou hodnotu hrube mzdy.
     * 
     * @param iJmeno Inicializuje jméno zaměstnance
     * @param iPrijmeni Inicializuje příjmení zaměstnance
     * @param iHrubaMzda Inicializuje hrubou mzdu zaměstnance v korunách
     * 
     */
    public Zamestnanec(String iJmeno, String iPrijmeni, double iHrubaMzda)
    {
       jmeno = iJmeno;
       prijmeni = iPrijmeni;
       if(iHrubaMzda > 0)
            hrubaMzda = iHrubaMzda;
    }


//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY INSTANCÍ ================================================
//== OSTATNÍ NESOUKROMÉ  METODY INSTANCÍ =======================================
//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================
//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== VNOŘENÉ A VNITŘNÍ TŘÍDY ===================================================
//== TESTOVACÍ METODY A TŘÍDY ==================================================
//
//     /***************************************************************************
//      * Testovací metoda.
//      */
//     public static void test()
//     {
//          Zamestnanec instance = new Zamestnanec();
//     }
//     /** @param args Parametry příkazového řádku - nepoužité. */
//     public static void main( String... args ) { test(); }
}
